Index: ObsoleteFiles.inc
===================================================================
--- ObsoleteFiles.inc	(revision 195689)
+++ ObsoleteFiles.inc	(working copy)
@@ -14,6 +14,10 @@
 # The file is partitioned: OLD_FILES first, then OLD_LIBS and OLD_DIRS last.
 #
 
+# 20090713: vimage container structs removed.
+OLD_FILES+=usr/include/netinet/vinet.h
+OLD_FILES+=usr/include/netinet6/vinet6.h
+OLD_FILES+=usr/include/netipsec/vipsec.h
 # 20090709: msgctl.3 msgget.3 msgrcv.3 msgsnd.3 manual pages moved
 OLD_FILES+=usr/share/man/man3/msgctl.3.gz
 OLD_FILES+=usr/share/man/man3/msgget.3.gz
Index: sys/conf/files
===================================================================
--- sys/conf/files	(revision 195689)
+++ sys/conf/files	(working copy)
@@ -1989,7 +1989,7 @@
 kern/kern_timeout.c		standard
 kern/kern_umtx.c		standard
 kern/kern_uuid.c		standard
-kern/kern_vimage.c		standard
+kern/kern_vimage.c		optional vimage
 kern/kern_xxx.c			standard
 kern/link_elf.c			standard
 kern/linker_if.m		standard
@@ -2231,6 +2231,7 @@
 net/rtsock.c			standard
 net/slcompress.c		optional netgraph_vjc | sppp | \
 					 netgraph_sppp
+net/vnet.c			optional vimage
 net/zlib.c			optional crypto | geom_uzip | ipsec | \
 					 mxge | netgraph_deflate | \
 					 ddb_ctf
Index: sys/conf/options
===================================================================
--- sys/conf/options	(revision 195689)
+++ sys/conf/options	(working copy)
@@ -823,7 +823,6 @@
 
 # Virtualize the network stack
 VIMAGE			opt_global.h
-VIMAGE_GLOBALS		opt_global.h
 
 # Common Flash Interface (CFI) options
 CFI_SUPPORT_STRATAFLASH	opt_cfi.h
Index: sys/nfsclient/nfs_vnops.c
===================================================================
--- sys/nfsclient/nfs_vnops.c	(revision 195689)
+++ sys/nfsclient/nfs_vnops.c	(working copy)
@@ -82,7 +82,6 @@
 #include <net/if.h>
 #include <netinet/in.h>
 #include <netinet/in_var.h>
-#include <netinet/vinet.h>
 
 #include <machine/stdarg.h>
 
@@ -1553,7 +1552,6 @@
 			*tl = txdr_unsigned(NFSV3CREATE_EXCLUSIVE);
 			tl = nfsm_build(u_int32_t *, NFSX_V3CREATEVERF);
 #ifdef INET
-			INIT_VNET_INET(curvnet);
 			IN_IFADDR_RLOCK();
 			if (!TAILQ_EMPTY(&V_in_ifaddrhead))
 				*tl++ = IA_SIN(TAILQ_FIRST(&V_in_ifaddrhead))->sin_addr.s_addr;
Index: sys/nfsclient/bootp_subr.c
===================================================================
--- sys/nfsclient/bootp_subr.c	(revision 195689)
+++ sys/nfsclient/bootp_subr.c	(working copy)
@@ -358,7 +358,6 @@
 void
 bootpboot_p_rtlist(void)
 {
-	INIT_VNET_NET(curvnet);
 	struct radix_node_head *rnh;
 
 	printf("Routing table:\n");
@@ -387,7 +386,6 @@
 void
 bootpboot_p_iflist(void)
 {
-	INIT_VNET_NET(curvnet);
 	struct ifnet *ifp;
 	struct ifaddr *ifa;
 
@@ -1597,7 +1595,6 @@
 void
 bootpc_init(void)
 {
-	INIT_VNET_NET(curvnet);
 	struct bootpc_ifcontext *ifctx, *nctx;	/* Interface BOOTP contexts */
 	struct bootpc_globalcontext *gctx; 	/* Global BOOTP context */
 	struct ifnet *ifp;
Index: sys/nfsclient/nfs_diskless.c
===================================================================
--- sys/nfsclient/nfs_diskless.c	(revision 195689)
+++ sys/nfsclient/nfs_diskless.c	(working copy)
@@ -149,7 +149,6 @@
 void
 nfs_setup_diskless(void)
 {
-	INIT_VNET_NET(curvnet);
 	struct nfs_diskless *nd = &nfs_diskless;
 	struct ifnet *ifp;
 	struct ifaddr *ifa;
Index: sys/kern/link_elf_obj.c
===================================================================
--- sys/kern/link_elf_obj.c	(revision 195689)
+++ sys/kern/link_elf_obj.c	(working copy)
@@ -45,6 +45,8 @@
 
 #include <machine/elf.h>
 
+#include <net/vnet.h>
+
 #include <security/mac/mac_framework.h>
 
 #include <vm/vm.h>
@@ -346,6 +348,21 @@
 				    ef->progtab[pb].size);
 				dpcpu_copy(dpcpu, shdr[i].sh_size);
 				ef->progtab[pb].addr = dpcpu;
+#ifdef VIMAGE
+			} else if (ef->progtab[pb].name != NULL &&
+			    !strcmp(ef->progtab[pb].name, "set_vnet")) {
+				void *vnet_data;
+
+				vnet_data = vnet_data_alloc(shdr[i].sh_size);
+				if (vnet_data == NULL) {
+					error = ENOSPC;
+					goto out;
+				}
+				memcpy(vnet_data, ef->progtab[pb].addr,
+				    ef->progtab[pb].size);
+				vnet_data_copy(vnet_data, shdr[i].sh_size);
+				ef->progtab[pb].addr = vnet_data;
+#endif
 			}
 
 			/* Update all symbol values with the offset. */
@@ -737,6 +754,12 @@
 			    !strcmp(ef->progtab[pb].name, "set_pcpu"))
 				ef->progtab[pb].addr =
 				    dpcpu_alloc(shdr[i].sh_size);
+#ifdef VIMAGE
+			else if (ef->progtab[pb].name != NULL &&
+			    !strcmp(ef->progtab[pb].name, "set_vnet"))
+				ef->progtab[pb].addr =
+				    vnet_data_alloc(shdr[i].sh_size);
+#endif
 			else
 				ef->progtab[pb].addr =
 				    (void *)(uintptr_t)mapbase;
@@ -758,10 +781,21 @@
 					error = EINVAL;
 					goto out;
 				}
-				/* Initialize the per-cpu area. */
-				if (ef->progtab[pb].addr != (void *)mapbase)
+				/* Initialize the per-cpu or vnet area. */
+				if (ef->progtab[pb].addr != (void *)mapbase &&
+				    !strcmp(ef->progtab[pb].name, "set_pcpu"))
 					dpcpu_copy(ef->progtab[pb].addr,
 					    shdr[i].sh_size);
+#ifdef VIMAGE
+				else if (ef->progtab[pb].addr !=
+				    (void *)mapbase &&
+				    !strcmp(ef->progtab[pb].name, "set_vnet"))
+					vnet_data_copy(ef->progtab[pb].addr,
+					    shdr[i].sh_size);
+#endif
+				else
+					panic("link_elf_load_file: unexpected "
+					    "progbits type");
 			} else
 				bzero(ef->progtab[pb].addr, shdr[i].sh_size);
 
@@ -877,6 +911,11 @@
 			if (!strcmp(ef->progtab[i].name, "set_pcpu"))
 				dpcpu_free(ef->progtab[i].addr,
 				    ef->progtab[i].size);
+#ifdef VIMAGE
+			else if (!strcmp(ef->progtab[i].name, "set_vnet"))
+				vnet_data_free(ef->progtab[i].addr,
+				    ef->progtab[i].size);
+#endif
 		}
 	}
 	if (ef->preloaded) {
Index: sys/kern/uipc_domain.c
===================================================================
--- sys/kern/uipc_domain.c	(revision 195689)
+++ sys/kern/uipc_domain.c	(working copy)
@@ -106,14 +106,12 @@
 	.pru_sopoll =		pru_sopoll_notsupp,
 };
 
-#ifndef VIMAGE_GLOBALS
+#ifdef VIMAGE
 vnet_modinfo_t vnet_domain_modinfo = {
 	.vmi_id		= VNET_MOD_DOMAIN,
 	.vmi_name	= "domain",
 	.vmi_iattach	= net_init_domain,
-#ifdef VIMAGE
 	.vmi_idetach	= net_detach_domain,
-#endif
 };
 #endif
 
@@ -249,7 +247,7 @@
 		    "domainfinalize()\n", dp->dom_name);
 #endif
 	mtx_unlock(&dom_mtx);
-#ifndef VIMAGE_GLOBALS
+#ifdef VIMAGE
 	vnet_mod_register_multi(&vnet_domain_modinfo, dp, dp->dom_name);
 #else
 	net_init_domain(dp);
Index: sys/kern/kern_linker.c
===================================================================
--- sys/kern/kern_linker.c	(revision 195689)
+++ sys/kern/kern_linker.c	(working copy)
@@ -1334,23 +1334,8 @@
 				break;
 			}
 		}
-#ifndef VIMAGE_GLOBALS
-		/*
-		 * If the symbol is not found in global namespace,
-		 * try to look it up in the current vimage namespace.
-		 */
-		if (lf == NULL) {
-			CURVNET_SET(TD_TO_VNET(td));
-			error = vi_symlookup(&lookup, symstr);
-			CURVNET_RESTORE();
-			if (error == 0)
-				error = copyout(&lookup, uap->data,
-						sizeof(lookup));
-		}
-#else
 		if (lf == NULL)
 			error = ENOENT;
-#endif
 	}
 	KLD_UNLOCK();
 out:
Index: sys/kern/link_elf.c
===================================================================
--- sys/kern/link_elf.c	(revision 195689)
+++ sys/kern/link_elf.c	(working copy)
@@ -49,6 +49,8 @@
 
 #include <machine/elf.h>
 
+#include <net/vnet.h>
+
 #include <security/mac/mac_framework.h>
 
 #include <vm/vm.h>
@@ -111,6 +113,11 @@
     Elf_Addr		pcpu_start;	/* Pre-relocation pcpu set start. */
     Elf_Addr		pcpu_stop;	/* Pre-relocation pcpu set stop. */
     Elf_Addr		pcpu_base;	/* Relocated pcpu set address. */
+#ifdef VIMAGE
+    Elf_Addr		vnet_start;	/* Pre-relocation vnet set start. */
+    Elf_Addr		vnet_stop;	/* Pre-relocation vnet set stop. */
+    Elf_Addr		vnet_base;	/* Relocated vnet set address. */
+#endif
 #ifdef GDB
     struct link_map	gdb;		/* hooks for gdb */
 #endif
@@ -506,7 +513,37 @@
     return (0);
 }
 
+#ifdef VIMAGE
 static int
+parse_vnet(elf_file_t ef)
+{ 
+    int count;
+    int error;
+
+    ef->vnet_start = 0;
+    ef->vnet_stop = 0;
+    error = link_elf_lookup_set(&ef->lf, "vnet", (void ***)&ef->vnet_start,
+                               (void ***)&ef->vnet_stop, &count);
+    /* Error just means there is no vnet data set to relocate. */
+    if (error)
+        return (0);
+    count *= sizeof(void *);
+    /*
+     * Allocate space in the primary vnet area.  Copy in our initialization
+     * from the data section and then initialize all per-vnet storage from
+     * that.
+     */
+    ef->vnet_base = (Elf_Addr)(uintptr_t)vnet_data_alloc(count);
+    if (ef->vnet_base == (Elf_Addr)NULL)
+        return (ENOSPC);
+    memcpy((void *)ef->vnet_base, (void *)ef->vnet_start, count);
+    vnet_data_copy((void *)ef->vnet_base, count);
+
+    return (0);
+}
+#endif
+
+static int
 link_elf_link_preload(linker_class_t cls,
 		      const char* filename, linker_file_t *result)
 {
@@ -553,6 +590,10 @@
     error = parse_dynamic(ef);
     if (error == 0)
         error = parse_dpcpu(ef);
+#ifdef VIMAGE
+    if (error == 0)
+	error = parse_vnet(ef);
+#endif
     if (error) {
 	linker_file_unload(lf, LINKER_UNLOAD_FORCE);
 	return error;
@@ -838,6 +879,11 @@
     error = parse_dpcpu(ef);
     if (error)
         goto out;
+#ifdef VIMAGE
+    error = parse_vnet(ef);
+    if (error)
+        goto out;
+#endif
     link_elf_reloc_local(lf);
 
     VOP_UNLOCK(nd.ni_vp, 0);
@@ -942,6 +988,10 @@
     ef = (elf_file_t)lf;
     if (x >= ef->pcpu_start && x < ef->pcpu_stop)
 	return ((x - ef->pcpu_start) + ef->pcpu_base);
+#ifdef VIMAGE
+    if (x >= ef->vnet_start && x < ef->vnet_stop)
+	return ((x - ef->vnet_start) + ef->vnet_base);
+#endif
     return (x);
 }
 
@@ -954,6 +1004,11 @@
     if (ef->pcpu_base) {
         dpcpu_free((void *)ef->pcpu_base, ef->pcpu_stop - ef->pcpu_start);
     }
+#ifdef VIMAGE
+    if (ef->vnet_base) {
+        vnet_data_free((void *)ef->vnet_base, ef->vnet_stop - ef->vnet_start);
+    }
+#endif
 #ifdef GDB
     if (ef->gdb.l_ld) {
 	GDB_STATE(RT_DELETE);
Index: sys/kern/kern_sysctl.c
===================================================================
--- sys/kern/kern_sysctl.c	(revision 195689)
+++ sys/kern/kern_sysctl.c	(working copy)
@@ -59,6 +59,8 @@
 #include <sys/ktrace.h>
 #endif
 
+#include <net/vnet.h>
+
 #include <security/mac/mac_framework.h>
 
 #include <vm/vm.h>
@@ -936,33 +938,9 @@
 	return (error);
 }
 
-#ifdef VIMAGE
-int
-sysctl_handle_v_int(SYSCTL_HANDLER_ARGS)
-{
-	int tmpout, error = 0;
- 
-	SYSCTL_RESOLVE_V_ARG1();
- 
-	/*
-	 * Attempt to get a coherent snapshot by making a copy of the data.
-	 */
-	tmpout = *(int *)arg1;
-	error = SYSCTL_OUT(req, &tmpout, sizeof(int));
-
-	if (error || !req->newptr)
-		return (error);
-
-	if (!arg1)
-		error = EPERM;
-	else
-		error = SYSCTL_IN(req, arg1, sizeof(int));
-	return (error);
-}
-#endif
-
 /*
  * Based on on sysctl_handle_int() convert milliseconds into ticks.
+ * Note: this is used by TCP.
  */
 
 int
@@ -970,8 +948,11 @@
 {
 	int error, s, tt;
 
-	SYSCTL_RESOLVE_V_ARG1();
-
+#ifdef VIMAGE
+	if (arg1 != NULL)
+		arg1 = (void *)(TD_TO_VNET(req->td)->vnet_data_base +
+		    (uintptr_t)arg1);
+#endif
 	tt = *(int *)arg1;
 	s = (int)((int64_t)tt * 1000 / hz);
 
@@ -1097,47 +1078,6 @@
 	return (error);
 }
 
-#ifdef VIMAGE
-int
-sysctl_handle_v_string(SYSCTL_HANDLER_ARGS)
-{
-	int error=0;
-	char *tmparg;
-	size_t outlen;
-
-	SYSCTL_RESOLVE_V_ARG1();
-
-	/*
-	 * Attempt to get a coherent snapshot by copying to a
-	 * temporary kernel buffer.
-	 */
-retry:
-	outlen = strlen((char *)arg1)+1;
-	tmparg = malloc(outlen, M_SYSCTLTMP, M_WAITOK);
-
-	if (strlcpy(tmparg, (char *)arg1, outlen) >= outlen) {
-		free(tmparg, M_SYSCTLTMP);
-		goto retry;
-	}
-
-	error = SYSCTL_OUT(req, tmparg, outlen);
-	free(tmparg, M_SYSCTLTMP);
-
-	if (error || !req->newptr)
-		return (error);
-
-	if ((req->newlen - req->newidx) >= arg2) {
-		error = EINVAL;
-	} else {
-		arg2 = (req->newlen - req->newidx);
-		error = SYSCTL_IN(req, arg1, arg2);
-		((char *)arg1)[arg2] = '\0';
-	}
-
-	return (error);
-}
-#endif
-
 /*
  * Handle any kind of opaque data.
  * arg1 points to it, arg2 is the size.
@@ -1175,35 +1115,6 @@
 	return (error);
 }
 
-#ifdef VIMAGE
-int
-sysctl_handle_v_opaque(SYSCTL_HANDLER_ARGS)
-{
-	int error, tries;
-	u_int generation;
-	struct sysctl_req req2;
-
-	SYSCTL_RESOLVE_V_ARG1();
-
-	tries = 0;
-	req2 = *req;
-retry:
-	generation = curthread->td_generation;
-	error = SYSCTL_OUT(req, arg1, arg2);
-	if (error)
-		return (error);
-	tries++;
-	if (generation != curthread->td_generation && tries < 3) {
-		*req = req2;
-		goto retry;
-	}
-
-	error = SYSCTL_IN(req, arg1, arg2);
-
-	return (error);
-}
-#endif
-
 /*
  * Transfer functions to/from kernel space.
  * XXX: rather untested at this point
Index: sys/kern/kern_uuid.c
===================================================================
--- sys/kern/kern_uuid.c	(revision 195689)
+++ sys/kern/kern_uuid.c	(working copy)
@@ -89,7 +89,6 @@
 static void
 uuid_node(uint16_t *node)
 {
-	INIT_VNET_NET(curvnet);
 	struct ifnet *ifp;
 	struct ifaddr *ifa;
 	struct sockaddr_dl *sdl;
Index: sys/kern/kern_poll.c
===================================================================
--- sys/kern/kern_poll.c	(revision 195689)
+++ sys/kern/kern_poll.c	(working copy)
@@ -545,7 +545,6 @@
 static int
 poll_switch(SYSCTL_HANDLER_ARGS)
 {
-	INIT_VNET_NET(curvnet);
 	struct ifnet *ifp;
 	int error;
 	int val = polling;
Index: sys/kern/kern_vimage.c
===================================================================
--- sys/kern/kern_vimage.c	(revision 195689)
+++ sys/kern/kern_vimage.c	(working copy)
@@ -53,8 +53,6 @@
 #include <net/route.h>
 #include <net/vnet.h>
 
-#ifndef VIMAGE_GLOBALS
-
 MALLOC_DEFINE(M_VIMAGE, "vimage", "vimage resource container");
 MALLOC_DEFINE(M_VNET, "vnet", "network stack control block");
 MALLOC_DEFINE(M_VPROCG, "vprocg", "process group control block");
@@ -65,13 +63,11 @@
 static int vnet_mod_constructor(struct vnet_modlink *);
 static int vnet_mod_destructor(struct vnet_modlink *);
 
-#ifdef VIMAGE
 static struct vimage *vi_alloc(struct vimage *, char *);
 static int vi_destroy(struct vimage *);
 static struct vimage *vimage_get_next(struct vimage *, struct vimage *, int);
 static void vimage_relative_name(struct vimage *, struct vimage *,
     char *, int);
-#endif
 
 #define	VNET_LIST_WLOCK()						\
 	mtx_lock(&vnet_list_refc_mtx);					\
@@ -81,17 +77,11 @@
 #define	VNET_LIST_WUNLOCK()						\
 	mtx_unlock(&vnet_list_refc_mtx);
 
-#ifdef VIMAGE
 struct vimage_list_head vimage_head;
 struct vnet_list_head vnet_head;
 struct vprocg_list_head vprocg_head;
-#else
-#ifndef VIMAGE_GLOBALS
 struct vprocg vprocg_0;
-#endif
-#endif
 
-#ifdef VIMAGE
 struct cv vnet_list_condvar;
 struct mtx vnet_list_refc_mtx;
 int vnet_list_refc = 0;
@@ -100,9 +90,7 @@
 static u_int last_vprocg_id = 0;
 
 struct vnet *vnet0;
-#endif
 
-#ifdef VIMAGE
 
 /*
  * Move an ifnet to or from another vnet, specified by the jail id.  If a
@@ -396,9 +384,7 @@
 	return (NULL);
 }
 
-#endif /* VIMAGE */ /* User interface block */
 
-
 /*
  * Kernel interfaces and handlers.
  */
@@ -540,25 +526,11 @@
 	if (vml->vml_iarg)
 		printf("/%s", vml->vml_iname);
 	printf(": ");
-#ifdef VIMAGE
-	if (vmi->vmi_size)
-		printf("malloc(%zu); ", vmi->vmi_size);
-#endif
 	if (vmi->vmi_iattach != NULL)
 		printf("iattach()");
 	printf("\n");
 #endif
 
-#ifdef VIMAGE
-	if (vmi->vmi_size) {
-		void *mem = malloc(vmi->vmi_size, M_VNET,
-		    M_NOWAIT | M_ZERO);
-		if (mem == NULL) /* XXX should return error, not panic. */
-			panic("malloc for %s\n", vmi->vmi_name);
-		curvnet->mod_data[vmi->vmi_id] = mem;
-	}
-#endif
-
 	if (vmi->vmi_iattach != NULL)
 		vmi->vmi_iattach(vml->vml_iarg);
 
@@ -577,63 +549,15 @@
 	printf(": ");
 	if (vmi->vmi_idetach != NULL)
 		printf("idetach(); ");
-#ifdef VIMAGE
-	if (vmi->vmi_size)
-		printf("free()");
-#endif
 	printf("\n");
 #endif
 
 	if (vmi->vmi_idetach)
 		vmi->vmi_idetach(vml->vml_iarg);
 
-#ifdef VIMAGE
-	if (vmi->vmi_size) {
-		if (curvnet->mod_data[vmi->vmi_id] == NULL)
-			panic("vi_destroy: %s\n", vmi->vmi_name);
-		free(curvnet->mod_data[vmi->vmi_id], M_VNET);
-		curvnet->mod_data[vmi->vmi_id] = NULL;
-	}
-#endif
-
 	return (0);
 }
 
-/*
- * vi_symlookup() attempts to resolve name to address queries for
- * variables which have been moved from global namespace to virtualization
- * container structures, but are still directly accessed from legacy
- * userspace processes via kldsym(2) and kmem(4) interfaces.
- */
-int
-vi_symlookup(struct kld_sym_lookup *lookup, char *symstr)
-{
-	struct vnet_modlink *vml;
-	struct vnet_symmap *mapentry;
-
-	TAILQ_FOREACH(vml, &vnet_modlink_head, vml_mod_le) {
-		if (vml->vml_modinfo->vmi_symmap == NULL)
-			continue;
-		for (mapentry = vml->vml_modinfo->vmi_symmap;
-		    mapentry->name != NULL; mapentry++) {
-			if (strcmp(symstr, mapentry->name) == 0) {
-#ifdef VIMAGE
-				lookup->symvalue =
-				    (u_long) curvnet->mod_data[
-				    vml->vml_modinfo->vmi_id];
-				lookup->symvalue += mapentry->offset;
-#else
-				lookup->symvalue = (u_long) mapentry->offset;
-#endif
-				lookup->symsize = mapentry->size;
-				return (0);
-			}
-		}
-	}
-	return (ENOENT);
-}
-
-#ifdef VIMAGE
 struct vnet *
 vnet_alloc(void)
 {
@@ -642,6 +566,7 @@
 
 	vnet = malloc(sizeof(struct vnet), M_VNET, M_WAITOK | M_ZERO);
 	vnet->vnet_magic_n = VNET_MAGIC_N;
+	vnet_data_init(vnet);
 
 	/* Initialize / attach vnet module instances. */
 	CURVNET_SET_QUIET(vnet);
@@ -669,7 +594,6 @@
 	VNET_LIST_WUNLOCK();
 
 	CURVNET_SET_QUIET(vnet);
-	INIT_VNET_NET(vnet);
 
 	/* Return all inherited interfaces to their parent vnets. */
 	TAILQ_FOREACH_SAFE(ifp, &V_ifnet, if_link, nifp) {
@@ -685,10 +609,22 @@
 	CURVNET_RESTORE();
 
 	/* Hopefully, we are OK to free the vnet container itself. */
+	vnet_data_destroy(vnet);
 	vnet->vnet_magic_n = 0xdeadbeef;
 	free(vnet, M_VNET);
 }
 
+void
+vnet_foreach(void (*vnet_foreach_fn)(struct vnet *, void *), void *arg)
+{
+	struct vnet *vnet;
+
+	VNET_LIST_RLOCK();
+	LIST_FOREACH(vnet, &vnet_head, vnet_le)
+		vnet_foreach_fn(vnet, arg);
+	VNET_LIST_RUNLOCK();
+}
+
 static struct vimage *
 vi_alloc(struct vimage *parent, char *name)
 {
@@ -757,7 +693,6 @@
 
 	return (0);
 }
-#endif /* VIMAGE */
 
 static void
 vi_init(void *unused)
@@ -766,7 +701,6 @@
 	TAILQ_INIT(&vnet_modlink_head);
 	TAILQ_INIT(&vnet_modpending_head);
 
-#ifdef VIMAGE
 	LIST_INIT(&vimage_head);
 	LIST_INIT(&vprocg_head);
 	LIST_INIT(&vnet_head);
@@ -783,7 +717,6 @@
 	 * curvnet recursions.
 	 */
 	curvnet = prison0.pr_vnet = vnet0 = LIST_FIRST(&vnet_head);
-#endif
 }
 
 static void
@@ -791,9 +724,7 @@
 {
 	struct vnet_modlink *vml_iter;
 
-#ifdef VIMAGE
 	curvnet = NULL;
-#endif
 
 	if (TAILQ_EMPTY(&vnet_modpending_head))
 		return;
@@ -809,45 +740,21 @@
 
 SYSINIT(vimage, SI_SUB_VIMAGE, SI_ORDER_FIRST, vi_init, NULL);
 SYSINIT(vimage_done, SI_SUB_VIMAGE_DONE, SI_ORDER_FIRST, vi_init_done, NULL);
-#endif /* !VIMAGE_GLOBALS */
 
-#ifdef VIMAGE
 #ifdef DDB
-static void
-db_vnet_ptr(void *arg)
-{
-
-	if (arg)
-		db_printf(" %p", arg);
-	else
-#if SIZE_MAX == UINT32_MAX /* 32-bit arch */
-		db_printf("          0");
-#else /* 64-bit arch, most probaly... */
-		db_printf("                  0");
-#endif
-}
-
 DB_SHOW_COMMAND(vnets, db_show_vnets)
 {
 	VNET_ITERATOR_DECL(vnet_iter);
 
 #if SIZE_MAX == UINT32_MAX /* 32-bit arch */
 	db_printf("      vnet ifs socks");
-	db_printf("        net       inet      inet6      ipsec   netgraph\n");
 #else /* 64-bit arch, most probaly... */
 	db_printf("              vnet ifs socks");
-	db_printf("                net               inet              inet6              ipsec           netgraph\n");
 #endif
 	VNET_FOREACH(vnet_iter) {
 		db_printf("%p %3d %5d",
 		    vnet_iter, vnet_iter->ifcnt, vnet_iter->sockcnt);
-		db_vnet_ptr(vnet_iter->mod_data[VNET_MOD_NET]);
-		db_vnet_ptr(vnet_iter->mod_data[VNET_MOD_INET]);
-		db_vnet_ptr(vnet_iter->mod_data[VNET_MOD_INET6]);
-		db_vnet_ptr(vnet_iter->mod_data[VNET_MOD_IPSEC]);
-		db_vnet_ptr(vnet_iter->mod_data[VNET_MOD_NETGRAPH]);
 		db_printf("\n");
 	}
 }
 #endif
-#endif /* VIMAGE */
Index: sys/netinet/tcp_input.c
===================================================================
--- sys/netinet/tcp_input.c	(revision 195689)
+++ sys/netinet/tcp_input.c	(working copy)
@@ -86,12 +86,7 @@
 #ifdef TCPDEBUG
 #include <netinet/tcp_debug.h>
 #endif /* TCPDEBUG */
-#include <netinet/vinet.h>
 
-#ifdef INET6
-#include <netinet6/vinet6.h>
-#endif
-
 #ifdef IPSEC
 #include <netipsec/ipsec.h>
 #include <netipsec/ipsec6.h>
@@ -103,75 +98,82 @@
 
 static const int tcprexmtthresh = 3;
 
-#ifdef VIMAGE_GLOBALS
-struct	tcpstat tcpstat;
-int	blackhole;
-int	tcp_delack_enabled;
-int	drop_synfin;
-int	tcp_do_rfc3042;
-int	tcp_do_rfc3390;
-int	tcp_do_ecn;
-int	tcp_ecn_maxretries;
-int	tcp_insecure_rst;
-int	tcp_do_autorcvbuf;
-int	tcp_autorcvbuf_inc;
-int	tcp_autorcvbuf_max;
-int	tcp_do_rfc3465;
-int	tcp_abc_l_var;
-#endif
+VNET_DEFINE(struct tcpstat, tcpstat);
+VNET_DEFINE(int, blackhole);
+VNET_DEFINE(int, tcp_delack_enabled);
+VNET_DEFINE(int, drop_synfin);
+VNET_DEFINE(int, tcp_do_rfc3042);
+VNET_DEFINE(int, tcp_do_rfc3390);
+VNET_DEFINE(int, tcp_do_ecn);
+VNET_DEFINE(int, tcp_ecn_maxretries);
+VNET_DEFINE(int, tcp_insecure_rst);
+VNET_DEFINE(int, tcp_do_autorcvbuf);
+VNET_DEFINE(int, tcp_autorcvbuf_inc);
+VNET_DEFINE(int, tcp_autorcvbuf_max);
+VNET_DEFINE(int, tcp_do_rfc3465);
+VNET_DEFINE(int, tcp_abc_l_var);
 
-SYSCTL_V_STRUCT(V_NET, vnet_inet, _net_inet_tcp, TCPCTL_STATS, stats,
-    CTLFLAG_RW, tcpstat , tcpstat,
+SYSCTL_VNET_STRUCT(_net_inet_tcp, TCPCTL_STATS, stats, CTLFLAG_RW,
+    &VNET_NAME(tcpstat), tcpstat,
     "TCP statistics (struct tcpstat, netinet/tcp_var.h)");
 
 int tcp_log_in_vain = 0;
 SYSCTL_INT(_net_inet_tcp, OID_AUTO, log_in_vain, CTLFLAG_RW,
-    &tcp_log_in_vain, 0, "Log all incoming TCP segments to closed ports");
+    &tcp_log_in_vain, 0,
+    "Log all incoming TCP segments to closed ports");
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_tcp, OID_AUTO, blackhole, CTLFLAG_RW,
-    blackhole, 0, "Do not send RST on segments to closed ports");
+SYSCTL_VNET_INT(_net_inet_tcp, OID_AUTO, blackhole, CTLFLAG_RW,
+    &VNET_NAME(blackhole), 0,
+    "Do not send RST on segments to closed ports");
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_tcp, OID_AUTO, delayed_ack,
-    CTLFLAG_RW, tcp_delack_enabled, 0,
+SYSCTL_VNET_INT(_net_inet_tcp, OID_AUTO, delayed_ack, CTLFLAG_RW,
+    &VNET_NAME(tcp_delack_enabled), 0,
     "Delay ACK to try and piggyback it onto a data packet");
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_tcp, OID_AUTO, drop_synfin,
-    CTLFLAG_RW, drop_synfin, 0, "Drop TCP packets with SYN+FIN set");
+SYSCTL_VNET_INT(_net_inet_tcp, OID_AUTO, drop_synfin, CTLFLAG_RW,
+    &VNET_NAME(drop_synfin), 0,
+    "Drop TCP packets with SYN+FIN set");
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_tcp, OID_AUTO, rfc3042, CTLFLAG_RW,
-    tcp_do_rfc3042, 0, "Enable RFC 3042 (Limited Transmit)");
+SYSCTL_VNET_INT(_net_inet_tcp, OID_AUTO, rfc3042, CTLFLAG_RW,
+    &VNET_NAME(tcp_do_rfc3042), 0,
+    "Enable RFC 3042 (Limited Transmit)");
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_tcp, OID_AUTO, rfc3390, CTLFLAG_RW,
-    tcp_do_rfc3390, 0,
+SYSCTL_VNET_INT(_net_inet_tcp, OID_AUTO, rfc3390, CTLFLAG_RW,
+    &VNET_NAME(tcp_do_rfc3390), 0,
     "Enable RFC 3390 (Increasing TCP's Initial Congestion Window)");
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_tcp, OID_AUTO, rfc3465, CTLFLAG_RW,
-    tcp_do_rfc3465, 0,
+SYSCTL_VNET_INT(_net_inet_tcp, OID_AUTO, rfc3465, CTLFLAG_RW,
+    &VNET_NAME(tcp_do_rfc3465), 0,
     "Enable RFC 3465 (Appropriate Byte Counting)");
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_tcp, OID_AUTO, abc_l_var, CTLFLAG_RW,
-    tcp_abc_l_var, 2,
+
+SYSCTL_VNET_INT(_net_inet_tcp, OID_AUTO, abc_l_var, CTLFLAG_RW,
+    &VNET_NAME(tcp_abc_l_var), 2,
     "Cap the max cwnd increment during slow-start to this number of segments");
 
 SYSCTL_NODE(_net_inet_tcp, OID_AUTO, ecn, CTLFLAG_RW, 0, "TCP ECN");
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_tcp_ecn, OID_AUTO, enable,
-    CTLFLAG_RW, tcp_do_ecn, 0, "TCP ECN support");
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_tcp_ecn, OID_AUTO, maxretries,
-    CTLFLAG_RW, tcp_ecn_maxretries, 0, "Max retries before giving up on ECN");
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_tcp, OID_AUTO, insecure_rst,
-    CTLFLAG_RW, tcp_insecure_rst, 0,
+SYSCTL_VNET_INT(_net_inet_tcp_ecn, OID_AUTO, enable, CTLFLAG_RW,
+    &VNET_NAME(tcp_do_ecn), 0,
+    "TCP ECN support");
+
+SYSCTL_VNET_INT(_net_inet_tcp_ecn, OID_AUTO, maxretries, CTLFLAG_RW,
+    &VNET_NAME(tcp_ecn_maxretries), 0,
+    "Max retries before giving up on ECN");
+
+SYSCTL_VNET_INT(_net_inet_tcp, OID_AUTO, insecure_rst, CTLFLAG_RW,
+    &VNET_NAME(tcp_insecure_rst), 0,
     "Follow the old (insecure) criteria for accepting RST packets");
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_tcp, OID_AUTO, recvbuf_auto,
-    CTLFLAG_RW, tcp_do_autorcvbuf, 0,
+SYSCTL_VNET_INT(_net_inet_tcp, OID_AUTO, recvbuf_auto, CTLFLAG_RW,
+    &VNET_NAME(tcp_do_autorcvbuf), 0,
     "Enable automatic receive buffer sizing");
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_tcp, OID_AUTO, recvbuf_inc,
-    CTLFLAG_RW, tcp_autorcvbuf_inc, 0,
+SYSCTL_VNET_INT(_net_inet_tcp, OID_AUTO, recvbuf_inc, CTLFLAG_RW,
+    &VNET_NAME(tcp_autorcvbuf_inc), 0,
     "Incrementor step size of automatic receive buffer");
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_tcp, OID_AUTO, recvbuf_max,
-    CTLFLAG_RW, tcp_autorcvbuf_max, 0,
+SYSCTL_VNET_INT(_net_inet_tcp, OID_AUTO, recvbuf_max, CTLFLAG_RW,
+    &VNET_NAME(tcp_autorcvbuf_max), 0,
     "Max size of automatic receive buffer");
 
 int	tcp_read_locking = 1;
@@ -198,10 +200,8 @@
 SYSCTL_INT(_net_inet_tcp, OID_AUTO, wlock_looped, CTLFLAG_RD,
     &tcp_wlock_looped, 0, "");
 
-#ifdef VIMAGE_GLOBALS
-struct inpcbhead tcb;
-struct inpcbinfo tcbinfo;
-#endif
+VNET_DEFINE(struct inpcbhead, tcb);
+VNET_DEFINE(struct inpcbinfo, tcbinfo);
 #define	tcb6	tcb  /* for KAME src sync over BSD*'s */
 
 static void	 tcp_dooptions(struct tcpopt *, u_char *, int, int);
@@ -271,7 +271,6 @@
 int
 tcp6_input(struct mbuf **mp, int *offp, int proto)
 {
-	INIT_VNET_INET6(curvnet);
 	struct mbuf *m = *mp;
 	struct in6_ifaddr *ia6;
 
@@ -300,13 +299,6 @@
 void
 tcp_input(struct mbuf *m, int off0)
 {
-	INIT_VNET_INET(curvnet);
-#ifdef INET6
-	INIT_VNET_INET6(curvnet);
-#endif
-#ifdef IPSEC
-	INIT_VNET_IPSEC(curvnet);
-#endif
 	struct tcphdr *th;
 	struct ip *ip = NULL;
 	struct ipovly *ipov;
@@ -1083,7 +1075,6 @@
     struct tcpcb *tp, int drop_hdrlen, int tlen, uint8_t iptos,
     int ti_locked)
 {
-	INIT_VNET_INET(tp->t_vnet);
 	int thflags, acked, ourfinisacked, needoutput = 0;
 	int rstreason, todrop, win;
 	u_long tiwin;
@@ -2868,7 +2859,6 @@
 static void
 tcp_dooptions(struct tcpopt *to, u_char *cp, int cnt, int flags)
 {
-	INIT_VNET_INET(curvnet);
 	int opt, optlen;
 
 	to->to_flags = 0;
@@ -2996,7 +2986,6 @@
 static void
 tcp_xmit_timer(struct tcpcb *tp, int rtt)
 {
-	INIT_VNET_INET(tp->t_inpcb->inp_vnet);
 	int delta;
 
 	INP_WLOCK_ASSERT(tp->t_inpcb);
@@ -3103,7 +3092,6 @@
 tcp_mss_update(struct tcpcb *tp, int offer,
     struct hc_metrics_lite *metricptr, int *mtuflags)
 {
-	INIT_VNET_INET(tp->t_inpcb->inp_vnet);
 	int mss;
 	u_long maxmtu;
 	struct inpcb *inp = tp->t_inpcb;
@@ -3269,7 +3257,6 @@
 	int isipv6;
 #endif
 	KASSERT(tp != NULL, ("%s: tp == NULL", __func__));
-	INIT_VNET_INET(tp->t_vnet);
 	
 	tcp_mss_update(tp, offer, &metrics, &mtuflags);
 
@@ -3396,7 +3383,6 @@
 int
 tcp_mssopt(struct in_conninfo *inc)
 {
-	INIT_VNET_INET(curvnet);
 	int mss = 0;
 	u_long maxmtu = 0;
 	u_long thcmtu = 0;
Index: sys/netinet/udp_var.h
===================================================================
--- sys/netinet/udp_var.h	(revision 195689)
+++ sys/netinet/udp_var.h	(working copy)
@@ -119,12 +119,16 @@
 
 extern struct pr_usrreqs	udp_usrreqs;
 
-#ifdef VIMAGE_GLOBALS
-extern struct inpcbhead		udb;
-extern struct inpcbinfo		udbinfo;
-extern struct udpstat		udpstat;
-extern int			udp_blackhole;
-#endif
+VNET_DECLARE(struct inpcbhead, udb);
+VNET_DECLARE(struct inpcbinfo, udbinfo);
+VNET_DECLARE(struct udpstat, udpstat);
+VNET_DECLARE(int, udp_blackhole);
+
+#define	V_udb			VNET_GET(udb)
+#define	V_udbinfo		VNET_GET(udbinfo)
+#define	V_udpstat		VNET_GET(udpstat)
+#define	V_udp_blackhole		VNET_GET(udp_blackhole)
+
 extern u_long			udp_sendspace;
 extern u_long			udp_recvspace;
 extern int			udp_log_in_vain;
Index: sys/netinet/in.c
===================================================================
--- sys/netinet/in.c	(revision 195689)
+++ sys/netinet/in.c	(working copy)
@@ -59,8 +59,9 @@
 #include <netinet/in_var.h>
 #include <netinet/in_pcb.h>
 #include <netinet/ip_var.h>
-#include <netinet/vinet.h>
 #include <netinet/igmp_var.h>
+#include <netinet/udp.h>
+#include <netinet/udp_var.h>
 
 static int in_mask2len(struct in_addr *);
 static void in_len2mask(struct in_addr *, int);
@@ -74,17 +75,19 @@
 	    struct in_ifaddr *, struct sockaddr_in *, int);
 static void	in_purgemaddrs(struct ifnet *);
 
-#ifdef VIMAGE_GLOBALS
-static int subnetsarelocal;
-static int sameprefixcarponly;
-extern struct inpcbinfo ripcbinfo;
-#endif
+static VNET_DEFINE(int, subnetsarelocal);
+static VNET_DEFINE(int, sameprefixcarponly);
+VNET_DECLARE(struct inpcbinfo, ripcbinfo);
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_ip, OID_AUTO, subnets_are_local,
-	CTLFLAG_RW, subnetsarelocal, 0,
+#define	V_subnetsarelocal		VNET_GET(subnetsarelocal)
+#define	V_sameprefixcarponly		VNET_GET(sameprefixcarponly)
+#define	V_ripcbinfo			VNET_GET(ripcbinfo)
+
+SYSCTL_VNET_INT(_net_inet_ip, OID_AUTO, subnets_are_local, CTLFLAG_RW,
+	&VNET_NAME(subnetsarelocal), 0,
 	"Treat all subnets as directly connected");
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_ip, OID_AUTO, same_prefix_carp_only,
-	CTLFLAG_RW, sameprefixcarponly, 0,
+SYSCTL_VNET_INT(_net_inet_ip, OID_AUTO, same_prefix_carp_only, CTLFLAG_RW,
+	&VNET_NAME(sameprefixcarponly), 0,
 	"Refuse to create same prefixes on different interfaces");
 
 /*
@@ -96,7 +99,6 @@
 int
 in_localaddr(struct in_addr in)
 {
-	INIT_VNET_INET(curvnet);
 	register u_long i = ntohl(in.s_addr);
 	register struct in_ifaddr *ia;
 
@@ -127,7 +129,6 @@
 int
 in_localip(struct in_addr in)
 {
-	INIT_VNET_INET(curvnet);
 	struct in_ifaddr *ia;
 
 	IN_IFADDR_RLOCK();
@@ -225,7 +226,6 @@
 in_control(struct socket *so, u_long cmd, caddr_t data, struct ifnet *ifp,
     struct thread *td)
 {
-	INIT_VNET_INET(curvnet); /* both so and ifp can be NULL here! */
 	register struct ifreq *ifr = (struct ifreq *)data;
 	register struct in_ifaddr *ia, *iap;
 	register struct ifaddr *ifa;
@@ -816,8 +816,6 @@
 in_ifinit(struct ifnet *ifp, struct in_ifaddr *ia, struct sockaddr_in *sin,
     int scrub)
 {
-	INIT_VNET_NET(ifp->if_vnet);
-	INIT_VNET_INET(ifp->if_vnet);
 	register u_long i = ntohl(sin->sin_addr.s_addr);
 	struct sockaddr_in oldaddr;
 	struct rtentry *rt = NULL;
@@ -952,7 +950,6 @@
 static int
 in_addprefix(struct in_ifaddr *target, int flags)
 {
-	INIT_VNET_INET(curvnet);
 	struct in_ifaddr *ia;
 	struct in_addr prefix, mask, p, m;
 	int error;
@@ -1020,8 +1017,6 @@
 static int
 in_scrubprefix(struct in_ifaddr *target)
 {
-	INIT_VNET_NET(curvnet);
-	INIT_VNET_INET(curvnet);
 	struct in_ifaddr *ia;
 	struct in_addr prefix, mask, p;
 	int error;
@@ -1166,7 +1161,6 @@
 void
 in_ifdetach(struct ifnet *ifp)
 {
-	INIT_VNET_INET(ifp->if_vnet);
 
 	in_pcbpurgeif0(&V_ripcbinfo, ifp);
 	in_pcbpurgeif0(&V_udbinfo, ifp);
